/* 	HexHelperTest.java
 *	Copyright (c) 2006, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 2-aug-2006
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.util;

import org.brains2b.util.HexHelper;

import junit.framework.TestCase;

/** Junit test for org.brains2b.util.HexHelper
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 0.10 [2-aug-2006]
 * @see org.brains2b.util.HexHelper
 */
public class HexHelperTest extends TestCase {

    public HexHelperTest(String arg0) {
        super(arg0);
    }

    public void testEncode() {
        assertEquals("ff",HexHelper.encode(new byte[] { (byte) 255}));
        assertEquals("00",HexHelper.encode(new byte[] { (byte) 0}));
        assertEquals("0abb10",HexHelper.encode(new byte[] { (byte) 10,(byte) 187,(byte) 16}));
    }
    
    public void testDecode() {
        assertEquals((byte) 255, HexHelper.decode("ff")[0]);
        assertEquals((byte) 0, HexHelper.decode("00")[0]);
        compareByteArray(new byte[] { (byte) 10,(byte) 187,(byte) 16},HexHelper.decode("0abb10"));
    }
    
    public void compareByteArray(byte[] b1, byte[] b2) {
        assertEquals("byte arrays not of same length",b1.length,b2.length);
        for (int i=0;i<b1.length;i++) {
            if (b1[i]!=b2[i]) {
                assertTrue("byte arrays differ at index " + i,false);
            }
        }
    }
}
